web/src/openpaper/scannerdb/urls.py
# -*- coding: utf-8 -*-
from django.urls import re_path

from . import views


urlpatterns = [
    re_path(r'^$', views.home, name='home'),
    re_path(r'^report/(?P<report_id>[0-9]+)/$', views.report, name='report'),
    re_path(
        r'^scanner/(?P<scanner_id>[0-9]+)/$',
        views.scanner, name='scanner'
    ),
    re_path(
        r'^vendor/(?P<manufacturer_id>[0-9]+)/$',
        views.manufacturer, name='vendor'
    ),
    re_path(
        r'^report/(?P<report_id>[0-9]+)/delete$',
        views.delete_report, name='delete_report'
    ),
    re_path(
        r'^report/(?P<report_id>[0-9]+)/comment$',
        views.comment_report, name='comment_report'
    ),
    re_path(
        r'^report/(?P<report_id>[0-9]+)/traces_colorized/'
        '(?P<attachment_id>[0-9]+)/?',
        views.report_traces_colorized, name='report_traces_colorized'
    ),
    re_path(
        r'^report/(?P<report_id>[0-9]+)/validate$',
        views.validate_report, name='validate_report'
    ),
    re_path(
        r'^report/(?P<report_id>[0-9]+)/analyze$',
        views.analyze_report, name='analyze_report'
    ),
    re_path(
        r'^analyze_all$',
        views.analyze_all, name='analyze_all'
    ),
]

web/src/openpaper/urls.py
"""openpaper URL Configuration
"""
from django.conf.urls import include
from django.conf.urls.i18n import i18n_patterns
from django.contrib import admin
from django.contrib import sitemaps
from django.contrib.sitemaps.views import sitemap
from django.urls import (
    re_path,
    reverse
)


class RootViewSitemap(sitemaps.Sitemap):
    priority = 1.0
    changefreq = 'monthly'

    def items(self):
        return [
            'home:index',
        ]

    def location(self, item):
        return reverse(item)


class HighPriorityViewSitemap(sitemaps.Sitemap):
    priority = 0.75
    changefreq = 'monthly'

    def items(self):
        return [
        ]

    def location(self, item):
        return reverse(item)


class AveragePriorityViewSitemap(sitemaps.Sitemap):
    priority = 0.5
    changefreq = 'monthly'

    def items(self):
        return [
            'beacon:statistics',
            'home:opensource',
        ]

    def location(self, item):
        return reverse(item)


class LowPriorityViewSitemap(sitemaps.Sitemap):
    priority = 0.25
    changefreq = 'monthly'

    def items(self):
        return [
            'home:about',
        ]

    def location(self, item):
        return reverse(item)


sitemaps = {
    'root': RootViewSitemap,
    'high_prio': HighPriorityViewSitemap,
    'average_prio': AveragePriorityViewSitemap,
    'low_prio': LowPriorityViewSitemap,
}

urlpatterns = [
    re_path(r'^admin/', admin.site.urls),
    re_path(r'^api/', include('openpaper.api.urls')),
    re_path(r'^beacon/', include('openpaper.beacon.urls')),  # alias for Paperwork
    re_path(
        r'^dashboard/',
        include(('openpaper.dashboard.urls', 'dashboard'), namespace='dashboard')
    ),
    re_path(r'^i18n/', include('django.conf.urls.i18n')),
    # re_path(r'^robots\.txt', include('robots.urls')),
    re_path(  # alias for IronScanner
        r'^scannerdb/',
        include(
            ('openpaper.scannerdb.urls', 'scannerdb'),
            namespace="scannerdb_no_i18n"
        )
    ),
    re_path(
        r'^sitemap\.xml$', sitemap, {'sitemaps': sitemaps},
        name='django.contrib.sitemaps.views.sitemap'
    ),
]

urlpatterns += i18n_patterns(
    re_path(r'^', include(('openpaper.home.urls', 'home'), namespace='home')),
    re_path(
        r'^paperwork/',
        include(('openpaper.beacon.urls', 'beacon'), namespace='beacon')
    ),
    re_path(
        r'^scanner_db/',
        include(('openpaper.scannerdb.urls', 'scannerdb'), namespace='scannerdb')
    ),
)

web/src/openpaper/scannerdb/models.py
# see backend.models.scannerdb

web/src/openpaper/scannerdb/forms.py
from django import forms


class AdminCommentForm(forms.Form):
    reason = forms.CharField(label='Admin comment', max_length=255)

web/src/openpaper/api/views/scannerdb.py
import django.core.mail
import django.http
import django.shortcuts
import django.views

import rest_framework
import rest_framework.response
import rest_framework.viewsets

import openpaper.backend.models.scannerdb
from ..serializers import scannerdb as serializers_scannerdb
from ..permissions import scannerdb as permissions_scannerdb


class ScannerManufacturerViewSet(rest_framework.viewsets.ModelViewSet):
    queryset = openpaper.backend.models.scannerdb.ScannerManufacturer.objects.all(
    ).order_by("name")
    serializer_class = (
        serializers_scannerdb.ScannerManufacturerSerializer
    )
    permission_classes = [permissions_scannerdb.ScannerDbHasKeyOrReadOnly]


class ScannerViewSet(rest_framework.viewsets.ModelViewSet):
    queryset = openpaper.backend.models.scannerdb.Scanner.objects.all().order_by(
        "manufacturer__name", "name"
    )
    serializer_class = serializers_scannerdb.ScannerSerializer
    permission_classes = [permissions_scannerdb.ScannerDbHasKeyOrReadOnly]


class ScanReportViewSet(rest_framework.viewsets.ModelViewSet):
    permission_classes = [permissions_scannerdb.ScannerDbReportPermission]
    # default serializer ; we override it only in retrieve()
    serializer_class = serializers_scannerdb.DefaultScanReportSerializer

    def get_queryset(self):
        queryset = openpaper.backend.models.scannerdb.ScanReport.objects.order_by(
            "-creation_date"
        )
        if self.request.method not in rest_framework.permissions.SAFE_METHODS:
            return queryset
        return queryset.filter(moderated=True)

    def create(self, request):
        # custom create view that report the secret key.
        # this is the only time ever we want to report it.
        serializer = self.get_serializer(data=request.data)
        serializer.is_valid(raise_exception=True)
        self.perform_create(serializer)
        headers = self.get_success_headers(serializer.data)

        # a bit hackish, but does the trick
        data = serializer.data
        data['secret_key'] = serializer.instance.secret_key

        url = request.build_absolute_uri(
            serializer.instance.user_url
        )
        django.core.mail.mail_admins(
            "New scan report {}".format(serializer.instance.id),
            "New scan report available:\n" + url,
            fail_silently=True
        )

        return rest_framework.response.Response(
            data, status=rest_framework.status.HTTP_201_CREATED,
            headers=headers
        )

    def retrieve(self, request, pk=None):
        report = django.shortcuts.get_object_or_404(self.get_queryset(), pk=pk)
        serializer = (
            serializers_scannerdb.DetailedScanReportSerializer(
                report, context={'request': request}
            )
        )
        return rest_framework.response.Response(serializer.data)


class ScanReportAttachmentViewSet(rest_framework.viewsets.ModelViewSet):
    queryset = openpaper.backend.models.scannerdb.ScanReportAttachment.objects.filter()
    permission_classes = [
        permissions_scannerdb.ScannerDbReportAttachmentPermission
    ]
    serializer_class = serializers_scannerdb.ScanReportAttachmentSerializer


class ScanReportDataView(rest_framework.views.APIView):
    permission_classes = [permissions_scannerdb.ScannerDbReportPermission]

    def get_report(self, request, report_id, write=True):
        self.check_permissions(request)
        report = django.shortcuts.get_object_or_404(
            openpaper.backend.models.scannerdb.ScanReport.objects, pk=report_id
        )
        if write:
            self.check_object_permissions(request, report)
        return report

    def get(self, request, report_id, node_path):
        report = self.get_report(request, report_id, write=False)
        tree = report.get_tree(request)
        return django.http.response.JsonResponse(tree)

    def post(self, request, report_id):
        report = self.get_report(request, report_id, write=True)
        data = request.data['data']
        report.set_tree(data)
        return django.http.response.HttpResponse(status=201, reason="Created")


class ScanReportAttachmentDownload(django.views.View):
    def get(self, request, attachment_id, file_name):
        attachment = django.shortcuts.get_object_or_404(
            openpaper.backend.models.scannerdb.ScanReportAttachment.objects,
            pk=attachment_id
        )
        if attachment.file_name != file_name:
            raise django.http.Http404("Attachment not found")
        response = django.http.response.HttpResponse(
            attachment.attachment, content_type=attachment.mime_type
        )
        # response['Content-Disposition'] = 'attachment; filename={}'.format(
        #     attachment.file_name
        # )
        return response

web/src/openpaper/scannerdb/templates/scandb_base.html
{% extends "base.html" %}

{% load i18n %}
{% load static %}

{% block extra_headers %}
<link rel="stylesheet" href="{% static "openpaper_scandb.css" %}">
{% block scandb_extra_headers %}{% endblock %}
{% endblock %}

{% block body %}
<div id="scandb">
    <h1>{% block title %}{% endblock %}</h1>

    <div id="scandb_listing">
        <p>
        <a href="{% url 'scannerdb:home' %}">{% trans "Home" %}</a>
        </p>

        <ul>
            {% for manufacturer in manufacturers %}
            <li>
                {% if manufacturer != selected_manufacturer %}
                <a href="{% url 'scannerdb:vendor' manufacturer.id %}">{{ manufacturer.name }}</a>
                {% else %}
                <a href="{% url 'scannerdb:vendor' manufacturer.id %}" class="scandb_selected">{{ manufacturer.name }}</a>

                <ul>
                    {% for scanner in scanners %}
                    <li>
                        {% if scanner != selected_scanner %}
                        <a href="{% url 'scannerdb:scanner' scanner.id %}">{{ scanner.name }}</a>
                        {% else %}
                        <a href="{% url 'scannerdb:scanner' scanner.id %}" class="scandb_selected">{{ scanner.name }}</a>

                        <ul>
                            {% for report in reports %}
                            <li>
                                {% if not selected_report or report.id != selected_report.id %}
                                <a href="{% url 'scannerdb:report' report.id %}">{{ report.creation_date }}</a>
                                {% else %}
                                <a href="{% url 'scannerdb:report' report.id %}" class="scandb_selected">{{ report.creation_date }}</a>
                                {% endif %}
                            </li>
                            {% endfor %}
                        </ul>

                        {% endif %}
                    </li>
                    {% endfor %}
                </ul>

                {% endif %}
            </li>
            {% endfor %}
        </ul>
    </div>

    <div id="scandb_body">
        {% block scandb_body %}
        {% endblock %}
    </div>
</div>

{% endblock %}

web/src/openpaper/scannerdb/templates/scandb_home.html
{% extends "scandb_base.html" %}

{% load i18n %}
{% load static %}

{% block scandb_extra_headers %}
<meta name="keywords" content="Openpaper, openpaper.work, scanner, database, db, Linux, Windows, WIA, TWAIN">
<meta name="description" content="{% trans "Scanner database (Windows / Linux)" %}">
{% endblock %}

{% block title %}
{% blocktrans %}
Scanner Database
{% endblocktrans %}
{% endblock %}

{% block scandb_body %}

{% if user.is_authenticated %}
<h2>Reports waiting for moderation</h2>

{% if unmoderated %}
<ul>
    {% for report in unmoderated %}
    <li><a href="{% url 'scannerdb:report' report.id %}">{{ report.creation_date }}</a></li>
    {% endfor %}
</ul>
{% else %}
<p>None</p>
{% endif %}

<table>
    <tr style="text-align: center;">
        <td>
            <form action="{% url 'scannerdb:analyze_all' %}" method="post">
                {% csrf_token %}
                <input type="submit" value="Analyze all" />
            </form>
        </td>
</table>

<h2>Introduction</h2>
{% endif %}

<img src="{% static "flatbed_and_feeder.png" %}" style="float: right; margin: 20px; margin-right: 0px;" width="256" height="auto" />

{% blocktrans %}
<p>
This database stores detailed information regarding scanners, their drivers and
<a href="https://gitlab.gnome.org/World/OpenPaperwork/libinsane">Libinsane</a>'s
support of those.
</p>
<p>
<a href="https://gitlab.gnome.org/World/OpenPaperwork/libinsane">Libinsane</a>
allows programs like
<a href="https://openpaper.work/">Paperwork</a> to use scanners on many platforms
(Linux, *BSD, Windows, etc). However, many scanners and scanners' drivers have
their own quirks. This database helps identify them. It also helps figuring out
which scanners are already correctly supported, and which ones need improvements.
</p>
<p>This database can also be of help when looking for a new scanner:
It can give you a good hint at what scanner manufacturers and models are best
supported by third-party applications on both GNU/Linux and Windows.</p>
{% endblocktrans %}

<table>
    <tr>
        <td style="padding-top: 0px;">
            <img src="{% static "ironscanner.png" %}" style="float: left; margin: 20px; margin-left: 0px;" width="160" height="auto" />
        </td>
        <td style="padding-top: 0px;">

{% blocktrans %}
<h2 id="contribute">Contributing</h2>
{% endblocktrans %}

{% blocktrans %}
<p>
A test program has been created to collect data quickly and automatically: <em>IronScanner</em>.
</p>

<p>You just have to run the program, select the scanner, define some basic test settings,
and run a test scan. It will then send the results to this database.</p>

<ul style="list-style-type: circle;">
    <li><a href="https://download.openpaper.work/windows/x86/ironscanner-master-latest.exe">Windows executable (64bits)</a></li>
    <li><a href="https://download.openpaper.work/linux/amd64/ironscanner-master-latest.appimage">Linux executable</a></li>
    <li><a href="https://gitlab.gnome.org/World/OpenPaperwork/ironscanner">Sources</a></li>
</ul>

<p>
<strong>Beware</strong> of the paper you will use for testing. The scanned paper will be
published here.<br/>
If you don't know what paper to use, you can simply print and then scan one of those test pages:
<a href="https://download.openpaper.work/test_pages/testpage-redhat-a4.pdf">A4</a> /
<a href="https://download.openpaper.work/test_pages/testpage-redhat-letter.pdf">Letter</a>
</p>

<p>
Test scan reports are published under the license <a href="https://en.wikipedia.org/wiki/WTFPL">WTFPL v2</a>.
By submitting a report here, you accept to publish it under this license.
</p>

{% endblocktrans %}
        </td>
    </tr>
</table>


{% blocktrans %}
{% endblocktrans %}

{% blocktrans %}
<h2>REST API</h2>
{% endblocktrans %}

{% blocktrans %}
<p>
This scanner database can also be accessed through a
<a href="/api/v1/scannerdb/">REST API</a> (read-only).
</p>
{% endblocktrans %}

{% blocktrans %}
<h2>Statistics - Success rates</h2>
{% endblocktrans %}

{% blocktrans %}
<h3>Global</h3>
{% endblocktrans %}

<table>
	<tr>
		{% for s in stats.global %}
		<th>{{ s.os.title }}</th>
		{% endfor %}
	</tr>
	<tr>
		{% for s in stats.global %}
		{% if s.percent is None %}
		<td></td>
		{% elif s.percent == 0 %}
		<td style="color: red;">{{ s.percent }}%</td>
		{% elif s.percent == 100 %}
		<td style="color: green;">{{ s.percent }}%</td>
		{% else %}
		<td>{{ s.percent }}%</td>
		{% endif %}
		{% endfor %}
	</tr>
</table>

{% blocktrans %}
<h3>Per manufacturer</h3>
{% endblocktrans %}

<table>
	<tr>
		<th>{% trans "Manufacturer" %}</th>
		{% for o in stats.oses %}
		<th>{{ o.title }}</th>
		{% endfor %}
	</tr>
	{% for s in stats.per_manufacturer %}
	<tr>
		<td>
			<a href="{% url 'scannerdb:vendor' s.manufacturer.id %}">
			{{ s.manufacturer.name.title }}
			</a>
		</td>
		{% for p in s.stats %}
		{% if p.percent is None %}
		<td></td>
		{% elif p.percent == 0 %}
		<td style="color: red;">{{ p.percent }}%</td>
		{% elif p.percent == 100 %}
		<td style="color: green;">{{ p.percent }}%</td>
		{% else %}
		<td>{{ p.percent }}%</td>
		{% endif %}
		{% endfor %}
	</tr>
	{% endfor %}
</table>

{% endblock %}

web/src/openpaper/scannerdb/templates/scandb_report.html
{% extends "scandb_base.html" %}

{% load i18n %}
{% load static %}

{% block title %}
{% blocktrans with report_id=report_db.id vendor=report.scanner.vendor model=report.scanner.model %}
Scan report {{ report_id }} - {{ vendor }} {{ model }}
{% endblocktrans %}
{% endblock %}


{% block scandb_body %}

{% if report_db.admin_comment %}
{% blocktrans with admin_comment=report_db.admin_comment %}
<h2>Report status</h2>
<p style="font-weight: bold; color: #FF0000;">Administrator comment:</p>
<p>{{ admin_comment }}</p>
<p>Moderator: <a href="mailto:jflesch@openpaper.work">Jerome Flesch</a></p>
{% endblocktrans %}
{% elif not report_db.moderated %}
<h2>Report status</h2>
<p>Report not moderated yet</p>
<p>Moderator: <a href="mailto:jflesch@openpaper.work">Jerome Flesch</a></p>
{% endif %}

{% if user.is_authenticated %}
<table>
    <tr style="text-align: center;">
        {% if not report_db.moderated %}
        <td>
            <form action="{% url 'scannerdb:validate_report' report_db.id %}" method="post">
                {% csrf_token %}
                <input type="submit" value="Validate" />
            </form>
        </td>
        {% endif %}
        <td>
            <form action="{% url 'scannerdb:delete_report' report_db.id %}" method="post">
                {% csrf_token %}
                <input type="submit" value="Delete" />
            </form>
        </td>
        <td>
            <form action="{% url 'scannerdb:analyze_report' report_db.id %}" method="post">
                {% csrf_token %}
                <input type="submit" value="Analyze" />
            </form>
        </td>
        <td>
            <a href="{% url "admin:backend_scanreport_change" report_db.id %}">[admin]</a>
        </td>
    </tr>
    <tr style="text-align: center;">
        <td colspan="3">
            <form action="{% url 'scannerdb:comment_report' report_db.id %}" method="post">
                {% csrf_token %}
                {% for field in admin_comment_form %}
                {{ field }}
                {% endfor %}
                <input type="submit" value="Comment" />
            </form>
        </td>
    </tr>
</table>
{% endif %}

<h2>{% trans "Scanner" %}</h2>

<button class="scandb_accordion">{% trans "Information" %}</button>
<div class="scandb_panel scandb_active scandb_panel_extended">
    <table>
        <tr>
            <td>
                <ul>
                    {% blocktrans with vendor=report.scanner.vendor model=report.scanner.model nicename=report.scanner.nicename devid=report.scanner.devid type=report.scanner.type.title %}
                    <li>Manufacturer: {{ vendor }}</li>
                    <li>Model: {{ model }}</li>
                    <li>Nice name: {{ nicename }}</li>
                    <li>Device ID: {{ devid }}</li>
                    <li>Type: {{ type }}</li>
                    {% endblocktrans %}
                </ul>
            </td>
            <td>
                <img src="{% static scanner_type_img %}" alt="scanner type" />
            </td>
        </tr>
    </table>
</div>

{% if report.scanner.picture %}
<button class="scandb_accordion">{% trans "Photo" %}</button>
<div class="scandb_panel">
    <img src="{% url 'scannerdb_no_i18n:scanner_photo' report_db.id %}" alt="scanner photo" />
</div>
{% endif %}

<button class="scandb_accordion">{% trans "Available Settings" %}</button>
<div class="scandb_panel">
    <ol>
        {% for option in report.scanner.options.items %}
        <li>
            <div class="scandb_accordion">{{ option.0 }}</div>
            <div class="scandb_panel">
                <ul>
                    {% for opt_element in option.1.items %}
                    <li>{{ opt_element.0 }}: {{ opt_element.1 }}</li>
                    {% endfor %}
                </ul>
            </div>
        </li>
        {% endfor %}
    </ol>
</div>

<h2>{% trans "Test scan" %}</h2>

{% blocktrans with successful=successful os=report_db.os.title %}
<p>OS: {{ os }}</p>
<p>Test successful: {{ successful }}</p>
{% endblocktrans %}

<button class="scandb_accordion">{% trans "Configuration" %}</button>
<div class="scandb_panel">
    <ul>
        {% with config=report.scantest.config %}
        {% blocktrans with source=config.source resolution=config.resolution mode=config.mode %}
        <li>Source: {{ source }}</li>
        <li>Resolution: {{ resolution }} dpi</li>
        <li>Mode: {{ mode }}</li>
        {% endblocktrans %}
        {% endwith %}
    </ul>
</div>

{% if report.user.comment %}
<button class="scandb_accordion">{% trans "User comment" %}</button>
<div class="scandb_panel">
    <pre>{{ report.user.comment }}</pre>
</div>
{% endif %}

<button class="scandb_accordion">{% trans "Traces" %}</button>
<div class="scandb_panel">
    <p>
        {% for attachment in attachments %}
        {% if attachment.mime_type == "text/plain" %}
        {{ attachment.file_name }}:
        <a href="{{ attachment.download_url }}">[raw]</a>
        <a href="{% url 'scannerdb:report_traces_colorized' report_db.id attachment.id %}">[colorized]</a>
        {% endif %}
        {% endfor %}
    </p>
</div>

<button class="scandb_accordion">{% trans "Scan result" %}</button>
<div class="scandb_panel">
    <p>
        {% for attachment in attachments %}
        {% if attachment.is_image %}
        {{ attachment.file_name }}:<br/>
        <img src="{{ attachment.download_url }}" alt="scan result {{ attachment.file_name }}" />
        {% endif %}
        {% endfor %}
    </p>
    <ul>
        {% for attachment in attachments %}
        {% if not attachment.is_image %}
        <li>
            <a href="{{ attachment.download_url }}">{{ attachment.file_name }}</a>
        </li>
        {% endif %}
        {% endfor %}
    </ul>
</div>


<h2>{% trans "Additional information" %}</h2>

<button class="scandb_accordion">{% trans "Software" %}</button>
<div class="scandb_panel">
    <ul>
        <li>OS type: {{ report.system.sys_os_name }}</li>
        <li>Test program: {{ report.system.versions.test_program }}</li>
        <li>Scan library: {{ report.system.versions.scan_library }}</li>
        <li>Pillow: {{ report.system.versions.pillow }}</li>
        <li>Python version: {{ report.system.sys_software_python }}</li>
        <li>Architecture: {{ report.system.sys_platform_architecture }}</li>
        <li>Platform:
            <ul>
                <li>Short: {{ report.system.sys_software_system }}</li>
                <li>Detailed: {{ report.system.sys_platform_distribution }}</li>
                <li>Release: {{ report.system.sys_software_release }}</li>
                <li>System: {{ report.system.sys_software_system }}</li>
            </ul>
        </li>
    </ul>
</div>

<button class="scandb_accordion">{% trans "Hardware" %}</button>
<div class="scandb_panel">
    <ul>
        <li>Architecture: {{ report.system.sys_platform_architecture }}</li>
        <li>CPU frequency: {{ report.system.sys_cpu_freq }}</li>
        <li>Number of CPUs: {{ report.system.sys_cpu_count }}</li>
        <li>Processor: {{ report.system.sys_platform_processor }}</li>
        <li>Machine: {{ report.system.sys_platform_machine }}</li>
        <li>Memory: {{ report.system.sys_platform_mem }}</li>
    </ul>
</div>

{% if report.user.name %}
<button class="scandb_accordion">Reporter</button>
<div class="scandb_panel">
    <p>Reported by:
    {% if user.is_authenticated and report_db.user_email %}
    <a href="mailto:{{ report_db.user_email }}">{{ report.user.name }}</a>
    {% else %}
    [{{ report.user.name }}]
    {% endif %}
    </p>
</div>
{% endif %}

<p>REST API link:
    <a href="{% url 'scanreport-detail' report_db.id %}">
        {% url 'scanreport-detail' report_db.id %}
    </a>
</p>

<script type="text/javascript">
var acc = document.getElementsByClassName("scandb_accordion");
var i;

for (i = 0; i < acc.length; i++) {
    acc[i].addEventListener("click", function() {
        this.classList.toggle("scandb_active");

        var panel = this.nextElementSibling;
        if (panel.style.display === "block") {
            panel.style.display = "none";
            panel.style.overflow = "hidden";
        } else {
            panel.style.display = "block";
            panel.style.overflow = "auto";
        }
    });
}
</script>

{% endblock %}

web/src/openpaper/scannerdb/templates/scandb_scanner.html
{% extends "scandb_base.html" %}

{% load i18n %}
{% load static %}

{% block title %}
{% blocktrans with vendor_name=selected_manufacturer.name scanner_name=selected_scanner.name %}
Scanner {{ vendor_name }} {{ scanner_name }}
{% endblocktrans %}
{% endblock %}

{% block scandb_body %}

{% if user.is_authenticated %}
<p><a href="{% url "admin:backend_scanner_change" selected_scanner.id %}">[admin]</a></p>
{% endif %}

<img src="{% static scanner_type_img %}" alt="scanner type" width="256" height="auto" />

<table class="scandb_report_list">
    <tr>
        <th>{% trans "Date" %}</th>
        <th>{% trans "Scan successful" %}</th>
        <th>{% trans "OS" %}</th>
        <th>{% trans "Scan source" %}</th>
        <th>{% trans "Scan library" %}</th>
        <th>{% trans "Test program" %}</th>
    </tr>

    {% for report in reports %}
    <tr>
        <td><a href="{% url 'scannerdb:report' report.id %}">{{ report.creation_date }}</a></td>
        {% if report.successful %}
        <td style="color: green;">{% trans "Yes" %}</td>
        {% else %}
        <td style="color: red;">{% trans "No" %}</td>
        {% endif %}
        <td>{{ report.os.title }}</td>
        <td>{{ report.scan_source }}</td>
        <td>{{ report.scan_library }}</td>
        <td>{{ report.scan_program }}</td>
    </tr>
    {% endfor %}

</table>

{% endblock %}